/*	Momentum.h
**
**	Copyright 1995, mFactory, Inc.
**	All rights reserved.
*/

#pragma once

#ifndef _Momentum_
	#define _Momentum_

	typedef struct MomentumComp MomentumComp;

	#ifndef MSelf
		#define MComponentName Momentum
		#define MSelf MomentumComp
		#include "MFusion.h"
	#endif

	typedef struct MomentumComp {
		MEvent		f_activateEvent;
		MEvent		f_terminateEvent;
		MDouble		f_mass;
		MDouble		f_initialAngle;
		MDouble		f_initialMagnitude;
		MDouble		f_terminalVelocity;

		long		f_timeStamp;			// temporary fields
		double		f_accelerationX;
		double		f_accelerationY;
		double		f_velocityX;
		double		f_velocityY;
		double 		f_fractionalX;
		double		f_fractionalY;
	} MomentumComp;

	const short kMomentumRev = 0;

	enum {
		kMomentumTask, kMomentumNumProcs
	};

	const kMomentumSlot = kMBaseCompSlot + 1;

	#ifdef __cplusplus
		extern "C" {
	#endif

		MErr MomentumTask(MomentumComp *self, MTInfo *tinfo);

	#ifdef __cplusplus
		}
	#endif

#endif
